Index: apps/app_voicemail.c
===================================================================
--- apps/app_voicemail.c	(revision 23981)
+++ apps/app_voicemail.c	(working copy)
@@ -2596,9 +2596,14 @@
 				ast_log(LOG_WARNING, "Error opening text file for output\n");
 			res = play_record_review(chan, NULL, fn, vmmaxmessage, fmt, 1, vmu, &duration, dir, options->record_gain);
 			if (res == '0') {
-				if (txt) {
+				if (txt && EXISTS(dir,msgnum,fn,chan->language)) {
 					fclose(txt);
 					rename(tmptxtfile, txtfile);
+				} else if (!EXISTS(dir,msgnum,fn,chan->language)) {
+					if (option_debug) 
+						ast_log(LOG_DEBUG, "The .wav file is gone, so we should remove the .txt file too!\n");
+					fclose(txt);
+					unlink(tmptxtfile);	
 				}
 				goto transfer;
 			}
